// Function returns a random number between 1 and n
function rand(n){return(Math.floor(Math.random()*n+1));}

jQuery(document).ready(function(){
 
  // Disable HTML title attribute for slider images
  jQuery('.promo_slider img').removeAttr('title');
 
  // Get all instances of promo_slider on the page
  var sliders = jQuery('.promo_slider');
  
  // Cycle through each slider
  jQuery.each(sliders, function(){
	
	// Define current slider
	var currentSlider = this;
	
	// Get all panels
    var panels = jQuery('.panel', currentSlider);
	
	// Get total count of panels
    var panelCount = panels.length;
	
	// Set number for first panel
	var initialPanel = rand(panelCount);
	
	// Assign variable for setInterval
	var sliderInterval;
	
	// Set time delay
	var timeDelay = promo_slider_options.timeDelay;
	if( jQuery('.promo_slider_time_delay', currentSlider).html() ){
		timeDelay = jQuery('.promo_slider_time_delay', currentSlider).html();
	}
	
	// Set auto advance variable
	var autoAdvance = promo_slider_options.autoAdvance;
	if( jQuery(currentSlider).hasClass('auto_advance') ) autoAdvance = true;
	if( jQuery(currentSlider).hasClass('no_auto_advance') ) autoAdvance = false;
	
	// Hide all panels
	panels.hide();
	
	// Show initial panel and add class 'current' to active panel
	jQuery('.panel-' + initialPanel, currentSlider).show().addClass('current');
	
	if(panelCount > 1){
		
	  jQuery('.promo_slider_nav').show();
	
	  // Generate HTML for navigation
	  var navHTML = '';
	  jQuery.each(panels, function(index, object){
		newSpan = '<span title="' + jQuery(object).attr('value') + '">' + jQuery(object).attr('value') + '</span>';
		if( (index + 1) != panelCount){newSpan = newSpan + ' | ';}
		navHTML = navHTML + newSpan;
	  });
	  
	  // Insert HTML into nav
	  jQuery('.slider_selections', currentSlider).html(navHTML);
	  
	  // Set click functions for each span in the slider nav
	  var slideNav = jQuery('.slider_selections span', currentSlider);
	  jQuery.each(slideNav, function(index, object){
		jQuery(object).click(function(){ 
		  clearInterval(sliderInterval);
		  progress(jQuery(object).attr('title'), currentSlider, panelCount);
		  if(autoAdvance) sliderInterval = setInterval(function(){progress('forward', currentSlider, panelCount);}, (timeDelay * 1000));
		});
	  });
	  
	  // Set active span class to 'current'
	  jQuery('.slider_selections span[title=' + initialPanel + ']', currentSlider).addClass('current');
	  
	}
	
	// Create click functions for navigational divs
	jQuery('.move_forward', currentSlider).click(function(){ 
	  clearInterval(sliderInterval);
	  progress('forward', currentSlider, panelCount);
	  if(autoAdvance) sliderInterval = setInterval(function(){progress('forward', currentSlider, panelCount);}, (timeDelay * 1000));
	});
	jQuery('.move_backward', currentSlider).click(function(){
	  clearInterval(sliderInterval);
	  progress('backward', currentSlider, panelCount);
	  if(autoAdvance) sliderInterval = setInterval(function(){progress('forward', currentSlider, panelCount);}, (timeDelay * 1000));
	});
	
	// Begin auto advancement of slides
	if(autoAdvance) sliderInterval = setInterval(function(){progress('forward', currentSlider, panelCount);}, (timeDelay * 1000));
	
  });
  
  // Progress to selected panel
  function progress(value, currentSlider, panelCount){
	  
	  // Find number of current panel
	  var currentValue = Number(jQuery('div.current', currentSlider).attr('value'));

	  // Set value of new panel
  	  if(value == 'forward'){
		var newValue = currentValue + 1;
		if(newValue > panelCount){newValue = 1;}
	  }
	  else if(value == 'backward'){
		var newValue = currentValue - 1;
		if(newValue == 0){newValue = panelCount;}
	  }
	  else{
		var newValue = value;
	  }
	  
	  // Assign variables for ease of use
	  var currentItem = jQuery('.panel-' + currentValue, currentSlider);
	  var newItem = jQuery('.panel-' + newValue, currentSlider);
	  var currentSpan = jQuery('.slider_selections span[title=' + currentValue + ']', currentSlider);
	  var newSpan = jQuery('.slider_selections span[title=' + newValue + ']', currentSlider);
	  
	  // Add / Remove classes
	  currentItem.removeClass('current');
	  newItem.addClass('current');
	  currentSpan.removeClass('current');
	  newSpan.addClass('current');
	  
	  // Fade in / out
	  currentItem.fadeOut('fast', function(){
		newItem.fadeIn('fast');
	  });

  }

});